#!/bin/sh

VERSION="0.0.2r23"

echo
echo -e "\033[1mbuildpkg $VERSION\033[0m"
echo -e "\033[1mcopyright (c) 2001 by DiCE / PsychoMix\033[0m"
echo -e "\033[1mhttp://psychomix.dhs.org\033[0m"
echo

if [ "$UID" != "0" ]; then
  echo "ERROR: need to be root to proceed"
  echo
  exit
fi

DESTDIR=""

CONFDIR="/etc/buildpkg"
SBINDIR="$DESTDIR/sbin"
MANDIR="$DESTDIR/usr/man"
OWNER="root:root"
PERM="0755"

if [ ! -d $CONFDIR ]; then
  mkdir -p $CONFDIR
fi

if [ ! -d $CONFDIR/debian ]; then
  mkdir -p $CONFDIR/debian
fi

if [ ! -d $CONFDIR/redhat ]; then
  mkdir -p $CONFDIR/redhat
fi

if [ ! -d $SBINDIR ]; then
  mkdir -p $SBINDIR
fi

if [ ! -d $MANDIR/man1 ]; then
  mkdir -p $MANDIR/man1
fi

if [ -e $SBINDIR/buildpkg-$VERSION ]; then
  ( cd $SBINDIR && mv buildpkg-$VERSION buildpkg-$VERSION.old )
fi

cat ./buildpkg-$VERSION > $SBINDIR/buildpkg-$VERSION
chown $OWNER $SBINDIR/buildpkg-$VERSION
chmod $PERM $SBINDIR/buildpkg-$VERSION

( cd $SBINDIR && ./buildpkg-$VERSION --install )

for i in buildpkg-$VERSION.1 \
         buildpkg.1 \
         checkinstalllog.1 \
         find_deps.1 \
         mkinfodir.1 \
         mkskel.1 ;
do
  cat ./$i > $MANDIR/man1/$i
  chown $OWNER $MANDIR/man1/$i
  chmod 644 $MANDIR/man1/$i
  ( cd $MANDIR/man1
    if [ -e $i.gz ]; then
      rm -f $i.gz
    fi
    gzip -9 $i )
done

if [ -e $CONFDIR/buildpkg.conf ]; then
  echo "$CONFDIR/buildpkg.conf detected, save new file as buildpkg.conf.new"
  cat ./buildpkg.conf > $CONFDIR/buildpkg.conf.new
  chown $OWNER $CONFDIR/buildpkg.conf.new
  chmod 644 $CONFDIR/buildpkg.conf.new
else
  cat ./buildpkg.conf > $CONFDIR/buildpkg.conf
  chown $OWNER $CONFDIR/buildpkg.conf
  chmod 644 $CONFDIR/buildpkg.conf
fi

if [ -e $CONFDIR/buildpkg.jail ]; then
  echo "$CONFDIR/buildpkg.jail detected, save new file as $CONFDIR/buildpkg.jail.new"
  cat ./buildpkg.jail > $CONFDIR/buildpkg.jail.new
  chown $OWNER $CONFDIR/buildpkg.jail.new
  chmod 600 $CONFDIR/buildpkg.jail.new
else
  cat ./buildpkg.jail > $CONFDIR/buildpkg.jail
  chown $OWNER $CONFDIR/buildpkg.jail
  chmod 600 $CONFDIR/buildpkg.jail
fi

if [ ! -d $CONFDIR/debian ]; then
  mkdir -p $CONFDIR/debian
fi

for i in default.control \
         default.changelog \
         default.rules ;
do
  if [ -e $CONFDIR/debian/$i ]; then
    echo "$CONFDIR/debian/$i detected, save new file as $CONFDIR/debian/$i.new"
    cat ./debian/$i > $CONFDIR/debian/$i.new
    chown $OWNER $CONFDIR/debian/$i.new
    chmod 644 $CONFDIR/debian/$i.new
  else
    cat ./debian/$i > $CONFDIR/debian/$i
    chown $OWNER $CONFDIR/debian/$i
    chmod 644 $CONFDIR/debian/$i
  fi
done

if [ -e $CONFDIR/redhat/default.spec ]; then
  echo "$CONFDIR/redhat/default.spec detected, save new file as $CONFDIR/redhat/default.spec.new"
  cat ./redhat/default.spec > $CONFDIR/redhat/default.spec.new
  chown $OWNER $CONFDIR/redhat/default.spec.new
  chmod 644 $CONFDIR/redhat/default.spec.new
else
  cat ./redhat/default.spec > $CONFDIR/redhat/default.spec
  chown $OWNER $CONFDIR/redhat/default.spec
  chmod 644 $CONFDIR/redhat/default.spec
fi
